=== adm/cmake/TKIVtkDraw/CMakeLists.txt ===
set(TOOLKIT TKIVtkDraw)

set(TOOLKIT_MODULES
	IVtkDraw
)
set(TOOLKIT_DEPENDS
	TKernel
	TKBRep
	TKDraw
	TKG2d
	TKG3d
	TKGeomAlgo
	TKGeomBase
	TKMath
	TKMesh
	TKService
	TKTopAlgo
	TKV3d
	TKOpenGl
	TKIVtk
)

set(TOOLKIT_INCLUDE_DIRECTORIES ${TCL_INCLUDE_PATH} ${VTK_INCLUDE_DIRS})
set(TOOLKIT_LIBS ${TCL_LIBRARY} ${VTK_LIBRARIES} ${CSF_gdi32_LIB} ${CSF_advapi32_LIB} ${CSF_user32_LIB})

if (WIN32 OR OCE_OSX_USE_COCOA)
        set(TOOLKIT_INCLUDE_DIRECTORIES ${TOOLKIT_INCLUDE_DIRECTORIES} ${TK_INCLUDE_PATH})
        set(TOOLKIT_LIBS ${TOOLKIT_LIBS} ${TK_LIBRARY})
else()
        set(TOOLKIT_INCLUDE_DIRECTORIES ${TOOLKIT_INCLUDE_DIRECTORIES} ${X11_X11_INCLUDE_PATH} ${TK_INCLUDE_PATH})
        set(TOOLKIT_LIBS ${TOOLKIT_LIBS} ${TK_LIBRARY} ${X11_X11_LIB})
endif()

include(../BuildToolkit.cmake)
