=== adm/cmake/TKViewerTest/CMakeLists.txt ===
set(TOOLKIT TKViewerTest)

set(TOOLKIT_MODULES
	ViewerTest
)
set(TOOLKIT_DEPENDS
	TKGeomBase
	TKFillet
	TKBRep
	TKTopAlgo
	TKHLR
	TKernel
	TKMath
	TKNIS
	TKService
	TKShHealing
	TKBool
	TKPrim
	TKGeomAlgo
	TKG2d
	TKTopTest
	TKG3d
	TKOffset
	TKVoxel
	TKMesh
	TKV3d
	TKDraw
	TKOpenGl
)

if(WIN32)
	set(TOOLKIT_LIBS ${CSF_user32_LIB} ${CSF_gdi32_LIB})
else(WIN32)
	if (OCE_OSX_USE_COCOA)
		set(TOOLKIT_INCLUDE_DIRECTORIES ${TK_INCLUDE_PATH} ${OPENGL_INCLUDE_DIR})
		set(TOOLKIT_LIBS ${TK_LIBRARY})
	else(OCE_OSX_USE_COCOA)
		set(TOOLKIT_INCLUDE_DIRECTORIES ${X11_X11_INCLUDE_PATH} ${TK_INCLUDE_PATH} ${OPENGL_INCLUDE_DIR})
		set(TOOLKIT_LIBS ${TK_LIBRARY} ${X11_X11_LIB})
	endif(OCE_OSX_USE_COCOA)
endif(WIN32)

if(CMAKE_CONFIGURATION_TYPES OR NMAKE)
    set(TOOLKIT_LIBS_DEBUG ${FREETYPE_LIBRARY_DEBUG})
    set(TOOLKIT_LIBS_OPTIMIZED ${FREETYPE_LIBRARIES})
else(CMAKE_CONFIGURATION_TYPES OR NMAKE)
    set(TOOLKIT_LIBS ${TOOLKIT_LIBS} ${FREETYPE_LIBRARIES})
endif(CMAKE_CONFIGURATION_TYPES OR NMAKE)
set(TOOLKIT_INCLUDE_DIRECTORIES ${TOOLKIT_INCLUDE_DIRECTORIES} ${FREETYPE_INCLUDE_DIRS})

set(TOOLKIT_IS_PRIVATE TRUE)

include(../BuildToolkit.cmake)
